/* This module contains all common components for Publication & Daasets Landing Pages */
import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';
import { RouterModule } from '@angular/router';
import {PagingModule} from '../../utils/paging.module';

import {ShowAuthorsComponent} from './showAuthors.component';
import {ShowIdentifiersComponent} from './showIdentifiers.component';
import {ShowSubjectsComponent} from './showSubjects.component';
import {FundedByComponent} from './fundedBy.component';
import {PublishedInComponent} from './publishedIn.component';
import {AvailableOnComponent} from './availableOn.component';
import {TabTableComponent} from './tabTable.component';

@NgModule({
  imports: [
    CommonModule, FormsModule, RouterModule, PagingModule
  ],
  declarations: [
   ShowAuthorsComponent,ShowIdentifiersComponent,ShowSubjectsComponent,
   FundedByComponent,PublishedInComponent,AvailableOnComponent,TabTableComponent
  ],
  providers:[
  ],
  exports: [
    ShowAuthorsComponent,ShowIdentifiersComponent,ShowSubjectsComponent,
    FundedByComponent,PublishedInComponent,AvailableOnComponent,TabTableComponent
  ]
})
export class ResultLandingModule { }
