import { Injectable } from '@angular/core';
import { Router,CanActivate, ActivatedRouteSnapshot, RouterStateSnapshot, ActivatedRoute} from '@angular/router';
import {Observable}       from 'rxjs/Observable';
import {Session} from './utils/helper.class';
import {LoginErrorCodes} from './utils/guardHelper.class';

@Injectable()
export class FreeGuard implements CanActivate {

  constructor(private router: Router) {}

  canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): Observable<boolean> | boolean {
    var user;
    var valid = true;
    var loggedIn = false;
     var errorCode = LoginErrorCodes.NOT_LOGGIN;

    if(Session.isLoggedIn()){
      loggedIn = true;
      if(!Session.isLoggedIn()){
        loggedIn = false;
        valid = false;
        errorCode = LoginErrorCodes.NOT_VALID;
      }
    }

    if(!valid){
      // this.guardHelper.redirect("/user-info",errorCode,state.url);

      this.router.navigate(['/user-info'], { queryParams: { "errorCode": errorCode, "redirectUrl":  state.url } });
      return false;
    }
    return true;

  }
}
