import {Component, Input, Output, EventEmitter, ViewChild, ElementRef} from '@angular/core';
import {Observable}       from 'rxjs/Observable';
import {ActivatedRoute, Router} from '@angular/router';
import {Location} from '@angular/common';

import {ErrorCodes} from '../utils/properties/errorCodes';
import {RouterHelper} from '../utils/routerHelper.class';
import {Session} from '../login/utils/helper.class';

@Component({
    selector: 'reload',
    template: `
    <div id="tm-main" class=" uk-section  uk-margin-small-top tm-middle"   >
      <div uk-grid uk-grid>
       <div class="tm-main uk-width-1-1@s uk-width-1-1@m  uk-width-1-1@l uk-row-first ">
          <div class="uk-container uk-margin-top publication">
            Go to initial page....
          </div>
        </div>
      </div>
    </div>
     `
})
export class ReloadComponent {

  constructor (private element: ElementRef,
    private route: ActivatedRoute,
      private _router: Router,
       private location: Location
    ) {

   }

  public ngOnInit() {
    if (typeof document !== 'undefined') {
      this.element.nativeElement.scrollIntoView();
    }
      var URL = Session.getReloadUrl();

        if(URL && URL["path"] && URL["path"] != null && URL["path"] != ""){
          var url = URL["path"];
          var host = URL["host"];
          var paramsObject = ((URL["params"] && URL["params"] != null)? Session.getParamsObj(URL["params"]):null);
          if(host == (location.protocol+"//"+location.host)){
            if(paramsObject &&  paramsObject != null){
              Session.setReloadUrl("","","")
              this._router.navigate([url],{ queryParams: paramsObject});
            }else{
              Session.setReloadUrl("","","")
              this._router.navigate([url]);
            }
          }else{
            Session.setReloadUrl("","","")
            window.location.href = host+url+((URL["params"] && URL["params"] !=null)?((URL["params"].indexOf("?")==-1?"?":"")+URL["params"]):"");
          }

        }else{
          Session.setReloadUrl("","","")
          this._router.navigate(['/']);

        }
  }

}
